# Code generated by Lark OpenAPI.

from typing import Any, Optional, Union, Dict, List, Set, IO, Callable, Type
from lark_oapi.core.model import BaseRequest
from lark_oapi.core.enum import HttpMethod, AccessTokenType
from .create_app_data_asset_request_body import CreateAppDataAssetRequestBody


class CreateAppDataAssetRequest(BaseRequest):
    def __init__(self) -> None:
        super().__init__()
        self.tenant_type: Optional[str] = None
        self.app_id: Optional[str] = None
        self.request_body: Optional[CreateAppDataAssetRequestBody] = None

    @staticmethod
    def builder() -> "CreateAppDataAssetRequestBuilder":
        return CreateAppDataAssetRequestBuilder()


class CreateAppDataAssetRequestBuilder(object):

    def __init__(self) -> None:
        create_app_data_asset_request = CreateAppDataAssetRequest()
        create_app_data_asset_request.http_method = HttpMethod.POST
        create_app_data_asset_request.uri = "/open-apis/aily/v1/apps/:app_id/data_assets"
        create_app_data_asset_request.token_types = {AccessTokenType.USER, AccessTokenType.TENANT}
        self._create_app_data_asset_request: CreateAppDataAssetRequest = create_app_data_asset_request

    def tenant_type(self, tenant_type: str) -> "CreateAppDataAssetRequestBuilder":
        self._create_app_data_asset_request.tenant_type = tenant_type
        self._create_app_data_asset_request.add_query("tenant_type", tenant_type)
        return self

    def app_id(self, app_id: str) -> "CreateAppDataAssetRequestBuilder":
        self._create_app_data_asset_request.app_id = app_id
        self._create_app_data_asset_request.paths["app_id"] = str(app_id)
        return self

    def request_body(self, request_body: CreateAppDataAssetRequestBody) -> "CreateAppDataAssetRequestBuilder":
        self._create_app_data_asset_request.request_body = request_body
        self._create_app_data_asset_request.body = request_body
        return self

    def build(self) -> CreateAppDataAssetRequest:
        return self._create_app_data_asset_request
