# Code generated by Lark OpenAPI.

from typing import Any, Optional, Union, Dict, List, Set, IO, Callable, Type
from lark_oapi.core.model import BaseRequest
from lark_oapi.core.enum import HttpMethod, AccessTokenType
from .custom_org_create import CustomOrgCreate


class CreateCustomOrgRequest(BaseRequest):
    def __init__(self) -> None:
        super().__init__()
        self.client_token: Optional[str] = None
        self.user_id_type: Optional[str] = None
        self.request_body: Optional[CustomOrgCreate] = None

    @staticmethod
    def builder() -> "CreateCustomOrgRequestBuilder":
        return CreateCustomOrgRequestBuilder()


class CreateCustomOrgRequestBuilder(object):

    def __init__(self) -> None:
        create_custom_org_request = CreateCustomOrgRequest()
        create_custom_org_request.http_method = HttpMethod.POST
        create_custom_org_request.uri = "/open-apis/corehr/v2/custom_orgs"
        create_custom_org_request.token_types = {AccessTokenType.TENANT}
        self._create_custom_org_request: CreateCustomOrgRequest = create_custom_org_request

    def client_token(self, client_token: str) -> "CreateCustomOrgRequestBuilder":
        self._create_custom_org_request.client_token = client_token
        self._create_custom_org_request.add_query("client_token", client_token)
        return self

    def user_id_type(self, user_id_type: str) -> "CreateCustomOrgRequestBuilder":
        self._create_custom_org_request.user_id_type = user_id_type
        self._create_custom_org_request.add_query("user_id_type", user_id_type)
        return self

    def request_body(self, request_body: CustomOrgCreate) -> "CreateCustomOrgRequestBuilder":
        self._create_custom_org_request.request_body = request_body
        self._create_custom_org_request.body = request_body
        return self

    def build(self) -> CreateCustomOrgRequest:
        return self._create_custom_org_request
