# Code generated by Lark OpenAPI.

from typing import Any, Optional, Union, Dict, List, Set, IO, Callable, Type
from lark_oapi.core.model import BaseRequest
from lark_oapi.core.enum import HttpMethod, AccessTokenType
from .query_custom_org_request_body import QueryCustomOrgRequestBody


class QueryCustomOrgRequest(BaseRequest):
    def __init__(self) -> None:
        super().__init__()
        self.page_size: Optional[int] = None
        self.page_token: Optional[str] = None
        self.user_id_type: Optional[str] = None
        self.request_body: Optional[QueryCustomOrgRequestBody] = None

    @staticmethod
    def builder() -> "QueryCustomOrgRequestBuilder":
        return QueryCustomOrgRequestBuilder()


class QueryCustomOrgRequestBuilder(object):

    def __init__(self) -> None:
        query_custom_org_request = QueryCustomOrgRequest()
        query_custom_org_request.http_method = HttpMethod.POST
        query_custom_org_request.uri = "/open-apis/corehr/v2/custom_orgs/query"
        query_custom_org_request.token_types = {AccessTokenType.TENANT}
        self._query_custom_org_request: QueryCustomOrgRequest = query_custom_org_request

    def page_size(self, page_size: int) -> "QueryCustomOrgRequestBuilder":
        self._query_custom_org_request.page_size = page_size
        self._query_custom_org_request.add_query("page_size", page_size)
        return self

    def page_token(self, page_token: str) -> "QueryCustomOrgRequestBuilder":
        self._query_custom_org_request.page_token = page_token
        self._query_custom_org_request.add_query("page_token", page_token)
        return self

    def user_id_type(self, user_id_type: str) -> "QueryCustomOrgRequestBuilder":
        self._query_custom_org_request.user_id_type = user_id_type
        self._query_custom_org_request.add_query("user_id_type", user_id_type)
        return self

    def request_body(self, request_body: QueryCustomOrgRequestBody) -> "QueryCustomOrgRequestBuilder":
        self._query_custom_org_request.request_body = request_body
        self._query_custom_org_request.body = request_body
        return self

    def build(self) -> QueryCustomOrgRequest:
        return self._query_custom_org_request
