# Code generated by Lark OpenAPI.

from typing import Any, Optional, Union, Dict, List, Set, IO, Callable, Type
from lark_oapi.core.model import BaseRequest
from lark_oapi.core.enum import HttpMethod, AccessTokenType
from .remove_version_cost_allocation_request_body import RemoveVersionCostAllocationRequestBody


class RemoveVersionCostAllocationRequest(BaseRequest):
    def __init__(self) -> None:
        super().__init__()
        self.user_id_type: Optional[str] = None
        self.client_token: Optional[str] = None
        self.request_body: Optional[RemoveVersionCostAllocationRequestBody] = None

    @staticmethod
    def builder() -> "RemoveVersionCostAllocationRequestBuilder":
        return RemoveVersionCostAllocationRequestBuilder()


class RemoveVersionCostAllocationRequestBuilder(object):

    def __init__(self) -> None:
        remove_version_cost_allocation_request = RemoveVersionCostAllocationRequest()
        remove_version_cost_allocation_request.http_method = HttpMethod.POST
        remove_version_cost_allocation_request.uri = "/open-apis/corehr/v2/cost_allocations/remove_version"
        remove_version_cost_allocation_request.token_types = {AccessTokenType.TENANT}
        self._remove_version_cost_allocation_request: RemoveVersionCostAllocationRequest = remove_version_cost_allocation_request

    def user_id_type(self, user_id_type: str) -> "RemoveVersionCostAllocationRequestBuilder":
        self._remove_version_cost_allocation_request.user_id_type = user_id_type
        self._remove_version_cost_allocation_request.add_query("user_id_type", user_id_type)
        return self

    def client_token(self, client_token: str) -> "RemoveVersionCostAllocationRequestBuilder":
        self._remove_version_cost_allocation_request.client_token = client_token
        self._remove_version_cost_allocation_request.add_query("client_token", client_token)
        return self

    def request_body(self,
                     request_body: RemoveVersionCostAllocationRequestBody) -> "RemoveVersionCostAllocationRequestBuilder":
        self._remove_version_cost_allocation_request.request_body = request_body
        self._remove_version_cost_allocation_request.body = request_body
        return self

    def build(self) -> RemoveVersionCostAllocationRequest:
        return self._remove_version_cost_allocation_request
