# Code generated by Lark OpenAPI.

from typing import Any, Optional, Union, Dict, List, Set, IO, Callable, Type
from lark_oapi.core.model import BaseRequest
from lark_oapi.core.enum import HttpMethod, AccessTokenType
from .remove_version_default_cost_center_request_body import RemoveVersionDefaultCostCenterRequestBody


class RemoveVersionDefaultCostCenterRequest(BaseRequest):
    def __init__(self) -> None:
        super().__init__()
        self.client_token: Optional[str] = None
        self.user_id_type: Optional[str] = None
        self.request_body: Optional[RemoveVersionDefaultCostCenterRequestBody] = None

    @staticmethod
    def builder() -> "RemoveVersionDefaultCostCenterRequestBuilder":
        return RemoveVersionDefaultCostCenterRequestBuilder()


class RemoveVersionDefaultCostCenterRequestBuilder(object):

    def __init__(self) -> None:
        remove_version_default_cost_center_request = RemoveVersionDefaultCostCenterRequest()
        remove_version_default_cost_center_request.http_method = HttpMethod.POST
        remove_version_default_cost_center_request.uri = "/open-apis/corehr/v2/default_cost_centers/remove_version"
        remove_version_default_cost_center_request.token_types = {AccessTokenType.TENANT}
        self._remove_version_default_cost_center_request: RemoveVersionDefaultCostCenterRequest = remove_version_default_cost_center_request

    def client_token(self, client_token: str) -> "RemoveVersionDefaultCostCenterRequestBuilder":
        self._remove_version_default_cost_center_request.client_token = client_token
        self._remove_version_default_cost_center_request.add_query("client_token", client_token)
        return self

    def user_id_type(self, user_id_type: str) -> "RemoveVersionDefaultCostCenterRequestBuilder":
        self._remove_version_default_cost_center_request.user_id_type = user_id_type
        self._remove_version_default_cost_center_request.add_query("user_id_type", user_id_type)
        return self

    def request_body(self,
                     request_body: RemoveVersionDefaultCostCenterRequestBody) -> "RemoveVersionDefaultCostCenterRequestBuilder":
        self._remove_version_default_cost_center_request.request_body = request_body
        self._remove_version_default_cost_center_request.body = request_body
        return self

    def build(self) -> RemoveVersionDefaultCostCenterRequest:
        return self._remove_version_default_cost_center_request
