# Code generated by Lark OpenAPI.

from typing import Any, Optional, Union, Dict, List, Set, IO, Callable, Type
from lark_oapi.core.model import BaseRequest
from lark_oapi.core.enum import HttpMethod, AccessTokenType
from .update_version_default_cost_center_request_body import UpdateVersionDefaultCostCenterRequestBody


class UpdateVersionDefaultCostCenterRequest(BaseRequest):
    def __init__(self) -> None:
        super().__init__()
        self.client_token: Optional[str] = None
        self.user_id_type: Optional[str] = None
        self.request_body: Optional[UpdateVersionDefaultCostCenterRequestBody] = None

    @staticmethod
    def builder() -> "UpdateVersionDefaultCostCenterRequestBuilder":
        return UpdateVersionDefaultCostCenterRequestBuilder()


class UpdateVersionDefaultCostCenterRequestBuilder(object):

    def __init__(self) -> None:
        update_version_default_cost_center_request = UpdateVersionDefaultCostCenterRequest()
        update_version_default_cost_center_request.http_method = HttpMethod.POST
        update_version_default_cost_center_request.uri = "/open-apis/corehr/v2/default_cost_centers/update_version"
        update_version_default_cost_center_request.token_types = {AccessTokenType.TENANT}
        self._update_version_default_cost_center_request: UpdateVersionDefaultCostCenterRequest = update_version_default_cost_center_request

    def client_token(self, client_token: str) -> "UpdateVersionDefaultCostCenterRequestBuilder":
        self._update_version_default_cost_center_request.client_token = client_token
        self._update_version_default_cost_center_request.add_query("client_token", client_token)
        return self

    def user_id_type(self, user_id_type: str) -> "UpdateVersionDefaultCostCenterRequestBuilder":
        self._update_version_default_cost_center_request.user_id_type = user_id_type
        self._update_version_default_cost_center_request.add_query("user_id_type", user_id_type)
        return self

    def request_body(self,
                     request_body: UpdateVersionDefaultCostCenterRequestBody) -> "UpdateVersionDefaultCostCenterRequestBuilder":
        self._update_version_default_cost_center_request.request_body = request_body
        self._update_version_default_cost_center_request.body = request_body
        return self

    def build(self) -> UpdateVersionDefaultCostCenterRequest:
        return self._update_version_default_cost_center_request
