# Code generated by Lark OpenAPI.

from typing import Any, Optional, Union, Dict, List, Set, IO, Callable, Type
from lark_oapi.core.model import BaseRequest
from lark_oapi.core.enum import HttpMethod, AccessTokenType
from .folder import Folder


class CreateUserMailboxFolderRequest(BaseRequest):
    def __init__(self) -> None:
        super().__init__()
        self.user_mailbox_id: Optional[str] = None
        self.request_body: Optional[Folder] = None

    @staticmethod
    def builder() -> "CreateUserMailboxFolderRequestBuilder":
        return CreateUserMailboxFolderRequestBuilder()


class CreateUserMailboxFolderRequestBuilder(object):

    def __init__(self) -> None:
        create_user_mailbox_folder_request = CreateUserMailboxFolderRequest()
        create_user_mailbox_folder_request.http_method = HttpMethod.POST
        create_user_mailbox_folder_request.uri = "/open-apis/mail/v1/user_mailboxes/:user_mailbox_id/folders"
        create_user_mailbox_folder_request.token_types = {AccessTokenType.TENANT, AccessTokenType.USER}
        self._create_user_mailbox_folder_request: CreateUserMailboxFolderRequest = create_user_mailbox_folder_request

    def user_mailbox_id(self, user_mailbox_id: str) -> "CreateUserMailboxFolderRequestBuilder":
        self._create_user_mailbox_folder_request.user_mailbox_id = user_mailbox_id
        self._create_user_mailbox_folder_request.paths["user_mailbox_id"] = str(user_mailbox_id)
        return self

    def request_body(self, request_body: Folder) -> "CreateUserMailboxFolderRequestBuilder":
        self._create_user_mailbox_folder_request.request_body = request_body
        self._create_user_mailbox_folder_request.body = request_body
        return self

    def build(self) -> CreateUserMailboxFolderRequest:
        return self._create_user_mailbox_folder_request
