# Code generated by Lark OpenAPI.

from typing import Any, Optional, Union, Dict, List, Set, IO, Callable, Type
from lark_oapi.core.model import BaseRequest
from lark_oapi.core.enum import HttpMethod, AccessTokenType
from .mail_contact import MailContact


class CreateUserMailboxMailContactRequest(BaseRequest):
    def __init__(self) -> None:
        super().__init__()
        self.user_mailbox_id: Optional[str] = None
        self.request_body: Optional[MailContact] = None

    @staticmethod
    def builder() -> "CreateUserMailboxMailContactRequestBuilder":
        return CreateUserMailboxMailContactRequestBuilder()


class CreateUserMailboxMailContactRequestBuilder(object):

    def __init__(self) -> None:
        create_user_mailbox_mail_contact_request = CreateUserMailboxMailContactRequest()
        create_user_mailbox_mail_contact_request.http_method = HttpMethod.POST
        create_user_mailbox_mail_contact_request.uri = "/open-apis/mail/v1/user_mailboxes/:user_mailbox_id/mail_contacts"
        create_user_mailbox_mail_contact_request.token_types = {AccessTokenType.TENANT, AccessTokenType.USER}
        self._create_user_mailbox_mail_contact_request: CreateUserMailboxMailContactRequest = create_user_mailbox_mail_contact_request

    def user_mailbox_id(self, user_mailbox_id: str) -> "CreateUserMailboxMailContactRequestBuilder":
        self._create_user_mailbox_mail_contact_request.user_mailbox_id = user_mailbox_id
        self._create_user_mailbox_mail_contact_request.paths["user_mailbox_id"] = str(user_mailbox_id)
        return self

    def request_body(self, request_body: MailContact) -> "CreateUserMailboxMailContactRequestBuilder":
        self._create_user_mailbox_mail_contact_request.request_body = request_body
        self._create_user_mailbox_mail_contact_request.body = request_body
        return self

    def build(self) -> CreateUserMailboxMailContactRequest:
        return self._create_user_mailbox_mail_contact_request
