# Code generated by Lark OpenAPI.

from typing import Any, Optional, Union, Dict, List, Set, IO, Callable, Type
from lark_oapi.core.model import BaseRequest
from lark_oapi.core.enum import HttpMethod, AccessTokenType
from .rule import Rule


class CreateUserMailboxRuleRequest(BaseRequest):
    def __init__(self) -> None:
        super().__init__()
        self.user_mailbox_id: Optional[str] = None
        self.request_body: Optional[Rule] = None

    @staticmethod
    def builder() -> "CreateUserMailboxRuleRequestBuilder":
        return CreateUserMailboxRuleRequestBuilder()


class CreateUserMailboxRuleRequestBuilder(object):

    def __init__(self) -> None:
        create_user_mailbox_rule_request = CreateUserMailboxRuleRequest()
        create_user_mailbox_rule_request.http_method = HttpMethod.POST
        create_user_mailbox_rule_request.uri = "/open-apis/mail/v1/user_mailboxes/:user_mailbox_id/rules"
        create_user_mailbox_rule_request.token_types = {AccessTokenType.TENANT, AccessTokenType.USER}
        self._create_user_mailbox_rule_request: CreateUserMailboxRuleRequest = create_user_mailbox_rule_request

    def user_mailbox_id(self, user_mailbox_id: str) -> "CreateUserMailboxRuleRequestBuilder":
        self._create_user_mailbox_rule_request.user_mailbox_id = user_mailbox_id
        self._create_user_mailbox_rule_request.paths["user_mailbox_id"] = str(user_mailbox_id)
        return self

    def request_body(self, request_body: Rule) -> "CreateUserMailboxRuleRequestBuilder":
        self._create_user_mailbox_rule_request.request_body = request_body
        self._create_user_mailbox_rule_request.body = request_body
        return self

    def build(self) -> CreateUserMailboxRuleRequest:
        return self._create_user_mailbox_rule_request
