# Code generated by Lark OpenAPI.

from typing import Any, Optional, Union, Dict, List, Set, IO, Callable, Type
from lark_oapi.core.model import BaseRequest
from lark_oapi.core.enum import HttpMethod, AccessTokenType


class DeleteUserMailboxFolderRequest(BaseRequest):
    def __init__(self) -> None:
        super().__init__()
        self.user_mailbox_id: Optional[str] = None
        self.folder_id: Optional[int] = None

    @staticmethod
    def builder() -> "DeleteUserMailboxFolderRequestBuilder":
        return DeleteUserMailboxFolderRequestBuilder()


class DeleteUserMailboxFolderRequestBuilder(object):

    def __init__(self) -> None:
        delete_user_mailbox_folder_request = DeleteUserMailboxFolderRequest()
        delete_user_mailbox_folder_request.http_method = HttpMethod.DELETE
        delete_user_mailbox_folder_request.uri = "/open-apis/mail/v1/user_mailboxes/:user_mailbox_id/folders/:folder_id"
        delete_user_mailbox_folder_request.token_types = {AccessTokenType.TENANT, AccessTokenType.USER}
        self._delete_user_mailbox_folder_request: DeleteUserMailboxFolderRequest = delete_user_mailbox_folder_request

    def user_mailbox_id(self, user_mailbox_id: str) -> "DeleteUserMailboxFolderRequestBuilder":
        self._delete_user_mailbox_folder_request.user_mailbox_id = user_mailbox_id
        self._delete_user_mailbox_folder_request.paths["user_mailbox_id"] = str(user_mailbox_id)
        return self

    def folder_id(self, folder_id: int) -> "DeleteUserMailboxFolderRequestBuilder":
        self._delete_user_mailbox_folder_request.folder_id = folder_id
        self._delete_user_mailbox_folder_request.paths["folder_id"] = str(folder_id)
        return self

    def build(self) -> DeleteUserMailboxFolderRequest:
        return self._delete_user_mailbox_folder_request
