# Code generated by Lark OpenAPI.

from typing import Any, Optional, Union, Dict, List, Set, IO, Callable, Type
from lark_oapi.core.model import BaseRequest
from lark_oapi.core.enum import HttpMethod, AccessTokenType


class ListUserMailboxMailContactRequest(BaseRequest):
    def __init__(self) -> None:
        super().__init__()
        self.page_size: Optional[int] = None
        self.page_token: Optional[str] = None
        self.user_mailbox_id: Optional[str] = None

    @staticmethod
    def builder() -> "ListUserMailboxMailContactRequestBuilder":
        return ListUserMailboxMailContactRequestBuilder()


class ListUserMailboxMailContactRequestBuilder(object):

    def __init__(self) -> None:
        list_user_mailbox_mail_contact_request = ListUserMailboxMailContactRequest()
        list_user_mailbox_mail_contact_request.http_method = HttpMethod.GET
        list_user_mailbox_mail_contact_request.uri = "/open-apis/mail/v1/user_mailboxes/:user_mailbox_id/mail_contacts"
        list_user_mailbox_mail_contact_request.token_types = {AccessTokenType.TENANT, AccessTokenType.USER}
        self._list_user_mailbox_mail_contact_request: ListUserMailboxMailContactRequest = list_user_mailbox_mail_contact_request

    def page_size(self, page_size: int) -> "ListUserMailboxMailContactRequestBuilder":
        self._list_user_mailbox_mail_contact_request.page_size = page_size
        self._list_user_mailbox_mail_contact_request.add_query("page_size", page_size)
        return self

    def page_token(self, page_token: str) -> "ListUserMailboxMailContactRequestBuilder":
        self._list_user_mailbox_mail_contact_request.page_token = page_token
        self._list_user_mailbox_mail_contact_request.add_query("page_token", page_token)
        return self

    def user_mailbox_id(self, user_mailbox_id: str) -> "ListUserMailboxMailContactRequestBuilder":
        self._list_user_mailbox_mail_contact_request.user_mailbox_id = user_mailbox_id
        self._list_user_mailbox_mail_contact_request.paths["user_mailbox_id"] = str(user_mailbox_id)
        return self

    def build(self) -> ListUserMailboxMailContactRequest:
        return self._list_user_mailbox_mail_contact_request
