# Code generated by Lark OpenAPI.

from typing import Any, Optional, Union, Dict, List, Set, IO, Callable, Type
from lark_oapi.core.model import BaseRequest
from lark_oapi.core.enum import HttpMethod, AccessTokenType
from .rule import Rule


class UpdateUserMailboxRuleRequest(BaseRequest):
    def __init__(self) -> None:
        super().__init__()
        self.user_mailbox_id: Optional[str] = None
        self.rule_id: Optional[int] = None
        self.request_body: Optional[Rule] = None

    @staticmethod
    def builder() -> "UpdateUserMailboxRuleRequestBuilder":
        return UpdateUserMailboxRuleRequestBuilder()


class UpdateUserMailboxRuleRequestBuilder(object):

    def __init__(self) -> None:
        update_user_mailbox_rule_request = UpdateUserMailboxRuleRequest()
        update_user_mailbox_rule_request.http_method = HttpMethod.PUT
        update_user_mailbox_rule_request.uri = "/open-apis/mail/v1/user_mailboxes/:user_mailbox_id/rules/:rule_id"
        update_user_mailbox_rule_request.token_types = {AccessTokenType.TENANT, AccessTokenType.USER}
        self._update_user_mailbox_rule_request: UpdateUserMailboxRuleRequest = update_user_mailbox_rule_request

    def user_mailbox_id(self, user_mailbox_id: str) -> "UpdateUserMailboxRuleRequestBuilder":
        self._update_user_mailbox_rule_request.user_mailbox_id = user_mailbox_id
        self._update_user_mailbox_rule_request.paths["user_mailbox_id"] = str(user_mailbox_id)
        return self

    def rule_id(self, rule_id: int) -> "UpdateUserMailboxRuleRequestBuilder":
        self._update_user_mailbox_rule_request.rule_id = rule_id
        self._update_user_mailbox_rule_request.paths["rule_id"] = str(rule_id)
        return self

    def request_body(self, request_body: Rule) -> "UpdateUserMailboxRuleRequestBuilder":
        self._update_user_mailbox_rule_request.request_body = request_body
        self._update_user_mailbox_rule_request.body = request_body
        return self

    def build(self) -> UpdateUserMailboxRuleRequest:
        return self._update_user_mailbox_rule_request
