# Code generated by Lark OpenAPI.

import io
from typing import Any, Optional, Union, Dict, List, Set, IO, Callable, Type
from lark_oapi.core.const import UTF_8, CONTENT_TYPE, APPLICATION_JSON
from lark_oapi.core import JSON
from lark_oapi.core.token import verify
from lark_oapi.core.http import Transport
from lark_oapi.core.model import Config, RequestOption, RawResponse
from lark_oapi.core.utils import Files
from requests_toolbelt import MultipartEncoder
from ..model.subscribe_user_mailbox_event_request import SubscribeUserMailboxEventRequest
from ..model.subscribe_user_mailbox_event_response import SubscribeUserMailboxEventResponse
from ..model.subscription_user_mailbox_event_request import SubscriptionUserMailboxEventRequest
from ..model.subscription_user_mailbox_event_response import SubscriptionUserMailboxEventResponse
from ..model.unsubscribe_user_mailbox_event_request import UnsubscribeUserMailboxEventRequest
from ..model.unsubscribe_user_mailbox_event_response import UnsubscribeUserMailboxEventResponse


class UserMailboxEvent(object):
    def __init__(self, config: Config) -> None:
        self.config: Config = config

    def subscribe(self, request: SubscribeUserMailboxEventRequest,
                  option: Optional[RequestOption] = None) -> SubscribeUserMailboxEventResponse:
        if option is None:
            option = RequestOption()

        # 鉴权、获取 token
        verify(self.config, request, option)

        # 添加 content-type
        if request.body is not None:
            option.headers[CONTENT_TYPE] = f"{APPLICATION_JSON}; charset=utf-8"

        # 发起请求
        resp: RawResponse = Transport.execute(self.config, request, option)

        # 反序列化
        response: SubscribeUserMailboxEventResponse = JSON.unmarshal(str(resp.content, UTF_8),
                                                                     SubscribeUserMailboxEventResponse)
        response.raw = resp

        return response

    async def asubscribe(self, request: SubscribeUserMailboxEventRequest,
                         option: Optional[RequestOption] = None) -> SubscribeUserMailboxEventResponse:
        if option is None:
            option = RequestOption()

        # 鉴权、获取 token
        verify(self.config, request, option)

        # 发起请求
        resp: RawResponse = await Transport.aexecute(self.config, request, option)

        # 反序列化
        response: SubscribeUserMailboxEventResponse = JSON.unmarshal(str(resp.content, UTF_8),
                                                                     SubscribeUserMailboxEventResponse)
        response.raw = resp

        return response

    def subscription(self, request: SubscriptionUserMailboxEventRequest,
                     option: Optional[RequestOption] = None) -> SubscriptionUserMailboxEventResponse:
        if option is None:
            option = RequestOption()

        # 鉴权、获取 token
        verify(self.config, request, option)

        # 添加 content-type
        if request.body is not None:
            option.headers[CONTENT_TYPE] = f"{APPLICATION_JSON}; charset=utf-8"

        # 发起请求
        resp: RawResponse = Transport.execute(self.config, request, option)

        # 反序列化
        response: SubscriptionUserMailboxEventResponse = JSON.unmarshal(str(resp.content, UTF_8),
                                                                        SubscriptionUserMailboxEventResponse)
        response.raw = resp

        return response

    async def asubscription(self, request: SubscriptionUserMailboxEventRequest,
                            option: Optional[RequestOption] = None) -> SubscriptionUserMailboxEventResponse:
        if option is None:
            option = RequestOption()

        # 鉴权、获取 token
        verify(self.config, request, option)

        # 发起请求
        resp: RawResponse = await Transport.aexecute(self.config, request, option)

        # 反序列化
        response: SubscriptionUserMailboxEventResponse = JSON.unmarshal(str(resp.content, UTF_8),
                                                                        SubscriptionUserMailboxEventResponse)
        response.raw = resp

        return response

    def unsubscribe(self, request: UnsubscribeUserMailboxEventRequest,
                    option: Optional[RequestOption] = None) -> UnsubscribeUserMailboxEventResponse:
        if option is None:
            option = RequestOption()

        # 鉴权、获取 token
        verify(self.config, request, option)

        # 添加 content-type
        if request.body is not None:
            option.headers[CONTENT_TYPE] = f"{APPLICATION_JSON}; charset=utf-8"

        # 发起请求
        resp: RawResponse = Transport.execute(self.config, request, option)

        # 反序列化
        response: UnsubscribeUserMailboxEventResponse = JSON.unmarshal(str(resp.content, UTF_8),
                                                                       UnsubscribeUserMailboxEventResponse)
        response.raw = resp

        return response

    async def aunsubscribe(self, request: UnsubscribeUserMailboxEventRequest,
                           option: Optional[RequestOption] = None) -> UnsubscribeUserMailboxEventResponse:
        if option is None:
            option = RequestOption()

        # 鉴权、获取 token
        verify(self.config, request, option)

        # 发起请求
        resp: RawResponse = await Transport.aexecute(self.config, request, option)

        # 反序列化
        response: UnsubscribeUserMailboxEventResponse = JSON.unmarshal(str(resp.content, UTF_8),
                                                                       UnsubscribeUserMailboxEventResponse)
        response.raw = resp

        return response
