# Code generated by Lark OpenAPI.

import io
from typing import Any, Optional, Union, Dict, List, Set, IO, Callable, Type
from lark_oapi.core.const import UTF_8, CONTENT_TYPE, APPLICATION_JSON
from lark_oapi.core import JSON
from lark_oapi.core.token import verify
from lark_oapi.core.http import Transport
from lark_oapi.core.model import Config, RequestOption, RawResponse
from lark_oapi.core.utils import Files
from requests_toolbelt import MultipartEncoder
from ..model.create_user_mailbox_folder_request import CreateUserMailboxFolderRequest
from ..model.create_user_mailbox_folder_response import CreateUserMailboxFolderResponse
from ..model.delete_user_mailbox_folder_request import DeleteUserMailboxFolderRequest
from ..model.delete_user_mailbox_folder_response import DeleteUserMailboxFolderResponse
from ..model.list_user_mailbox_folder_request import ListUserMailboxFolderRequest
from ..model.list_user_mailbox_folder_response import ListUserMailboxFolderResponse
from ..model.patch_user_mailbox_folder_request import PatchUserMailboxFolderRequest
from ..model.patch_user_mailbox_folder_response import PatchUserMailboxFolderResponse


class UserMailboxFolder(object):
    def __init__(self, config: Config) -> None:
        self.config: Config = config

    def create(self, request: CreateUserMailboxFolderRequest,
               option: Optional[RequestOption] = None) -> CreateUserMailboxFolderResponse:
        if option is None:
            option = RequestOption()

        # 鉴权、获取 token
        verify(self.config, request, option)

        # 添加 content-type
        if request.body is not None:
            option.headers[CONTENT_TYPE] = f"{APPLICATION_JSON}; charset=utf-8"

        # 发起请求
        resp: RawResponse = Transport.execute(self.config, request, option)

        # 反序列化
        response: CreateUserMailboxFolderResponse = JSON.unmarshal(str(resp.content, UTF_8),
                                                                   CreateUserMailboxFolderResponse)
        response.raw = resp

        return response

    async def acreate(self, request: CreateUserMailboxFolderRequest,
                      option: Optional[RequestOption] = None) -> CreateUserMailboxFolderResponse:
        if option is None:
            option = RequestOption()

        # 鉴权、获取 token
        verify(self.config, request, option)

        # 发起请求
        resp: RawResponse = await Transport.aexecute(self.config, request, option)

        # 反序列化
        response: CreateUserMailboxFolderResponse = JSON.unmarshal(str(resp.content, UTF_8),
                                                                   CreateUserMailboxFolderResponse)
        response.raw = resp

        return response

    def delete(self, request: DeleteUserMailboxFolderRequest,
               option: Optional[RequestOption] = None) -> DeleteUserMailboxFolderResponse:
        if option is None:
            option = RequestOption()

        # 鉴权、获取 token
        verify(self.config, request, option)

        # 添加 content-type
        if request.body is not None:
            option.headers[CONTENT_TYPE] = f"{APPLICATION_JSON}; charset=utf-8"

        # 发起请求
        resp: RawResponse = Transport.execute(self.config, request, option)

        # 反序列化
        response: DeleteUserMailboxFolderResponse = JSON.unmarshal(str(resp.content, UTF_8),
                                                                   DeleteUserMailboxFolderResponse)
        response.raw = resp

        return response

    async def adelete(self, request: DeleteUserMailboxFolderRequest,
                      option: Optional[RequestOption] = None) -> DeleteUserMailboxFolderResponse:
        if option is None:
            option = RequestOption()

        # 鉴权、获取 token
        verify(self.config, request, option)

        # 发起请求
        resp: RawResponse = await Transport.aexecute(self.config, request, option)

        # 反序列化
        response: DeleteUserMailboxFolderResponse = JSON.unmarshal(str(resp.content, UTF_8),
                                                                   DeleteUserMailboxFolderResponse)
        response.raw = resp

        return response

    def list(self, request: ListUserMailboxFolderRequest,
             option: Optional[RequestOption] = None) -> ListUserMailboxFolderResponse:
        if option is None:
            option = RequestOption()

        # 鉴权、获取 token
        verify(self.config, request, option)

        # 添加 content-type
        if request.body is not None:
            option.headers[CONTENT_TYPE] = f"{APPLICATION_JSON}; charset=utf-8"

        # 发起请求
        resp: RawResponse = Transport.execute(self.config, request, option)

        # 反序列化
        response: ListUserMailboxFolderResponse = JSON.unmarshal(str(resp.content, UTF_8),
                                                                 ListUserMailboxFolderResponse)
        response.raw = resp

        return response

    async def alist(self, request: ListUserMailboxFolderRequest,
                    option: Optional[RequestOption] = None) -> ListUserMailboxFolderResponse:
        if option is None:
            option = RequestOption()

        # 鉴权、获取 token
        verify(self.config, request, option)

        # 发起请求
        resp: RawResponse = await Transport.aexecute(self.config, request, option)

        # 反序列化
        response: ListUserMailboxFolderResponse = JSON.unmarshal(str(resp.content, UTF_8),
                                                                 ListUserMailboxFolderResponse)
        response.raw = resp

        return response

    def patch(self, request: PatchUserMailboxFolderRequest,
              option: Optional[RequestOption] = None) -> PatchUserMailboxFolderResponse:
        if option is None:
            option = RequestOption()

        # 鉴权、获取 token
        verify(self.config, request, option)

        # 添加 content-type
        if request.body is not None:
            option.headers[CONTENT_TYPE] = f"{APPLICATION_JSON}; charset=utf-8"

        # 发起请求
        resp: RawResponse = Transport.execute(self.config, request, option)

        # 反序列化
        response: PatchUserMailboxFolderResponse = JSON.unmarshal(str(resp.content, UTF_8),
                                                                  PatchUserMailboxFolderResponse)
        response.raw = resp

        return response

    async def apatch(self, request: PatchUserMailboxFolderRequest,
                     option: Optional[RequestOption] = None) -> PatchUserMailboxFolderResponse:
        if option is None:
            option = RequestOption()

        # 鉴权、获取 token
        verify(self.config, request, option)

        # 发起请求
        resp: RawResponse = await Transport.aexecute(self.config, request, option)

        # 反序列化
        response: PatchUserMailboxFolderResponse = JSON.unmarshal(str(resp.content, UTF_8),
                                                                  PatchUserMailboxFolderResponse)
        response.raw = resp

        return response
