# Code generated by Lark OpenAPI.

import io
from typing import Any, Optional, Union, Dict, List, Set, IO, Callable, Type
from lark_oapi.core.const import UTF_8, CONTENT_TYPE, APPLICATION_JSON
from lark_oapi.core import JSON
from lark_oapi.core.token import verify
from lark_oapi.core.http import Transport
from lark_oapi.core.model import Config, RequestOption, RawResponse
from lark_oapi.core.utils import Files
from requests_toolbelt import MultipartEncoder
from ..model.create_user_mailbox_mail_contact_request import CreateUserMailboxMailContactRequest
from ..model.create_user_mailbox_mail_contact_response import CreateUserMailboxMailContactResponse
from ..model.delete_user_mailbox_mail_contact_request import DeleteUserMailboxMailContactRequest
from ..model.delete_user_mailbox_mail_contact_response import DeleteUserMailboxMailContactResponse
from ..model.list_user_mailbox_mail_contact_request import ListUserMailboxMailContactRequest
from ..model.list_user_mailbox_mail_contact_response import ListUserMailboxMailContactResponse
from ..model.patch_user_mailbox_mail_contact_request import PatchUserMailboxMailContactRequest
from ..model.patch_user_mailbox_mail_contact_response import PatchUserMailboxMailContactResponse


class UserMailboxMailContact(object):
    def __init__(self, config: Config) -> None:
        self.config: Config = config

    def create(self, request: CreateUserMailboxMailContactRequest,
               option: Optional[RequestOption] = None) -> CreateUserMailboxMailContactResponse:
        if option is None:
            option = RequestOption()

        # 鉴权、获取 token
        verify(self.config, request, option)

        # 添加 content-type
        if request.body is not None:
            option.headers[CONTENT_TYPE] = f"{APPLICATION_JSON}; charset=utf-8"

        # 发起请求
        resp: RawResponse = Transport.execute(self.config, request, option)

        # 反序列化
        response: CreateUserMailboxMailContactResponse = JSON.unmarshal(str(resp.content, UTF_8),
                                                                        CreateUserMailboxMailContactResponse)
        response.raw = resp

        return response

    async def acreate(self, request: CreateUserMailboxMailContactRequest,
                      option: Optional[RequestOption] = None) -> CreateUserMailboxMailContactResponse:
        if option is None:
            option = RequestOption()

        # 鉴权、获取 token
        verify(self.config, request, option)

        # 发起请求
        resp: RawResponse = await Transport.aexecute(self.config, request, option)

        # 反序列化
        response: CreateUserMailboxMailContactResponse = JSON.unmarshal(str(resp.content, UTF_8),
                                                                        CreateUserMailboxMailContactResponse)
        response.raw = resp

        return response

    def delete(self, request: DeleteUserMailboxMailContactRequest,
               option: Optional[RequestOption] = None) -> DeleteUserMailboxMailContactResponse:
        if option is None:
            option = RequestOption()

        # 鉴权、获取 token
        verify(self.config, request, option)

        # 添加 content-type
        if request.body is not None:
            option.headers[CONTENT_TYPE] = f"{APPLICATION_JSON}; charset=utf-8"

        # 发起请求
        resp: RawResponse = Transport.execute(self.config, request, option)

        # 反序列化
        response: DeleteUserMailboxMailContactResponse = JSON.unmarshal(str(resp.content, UTF_8),
                                                                        DeleteUserMailboxMailContactResponse)
        response.raw = resp

        return response

    async def adelete(self, request: DeleteUserMailboxMailContactRequest,
                      option: Optional[RequestOption] = None) -> DeleteUserMailboxMailContactResponse:
        if option is None:
            option = RequestOption()

        # 鉴权、获取 token
        verify(self.config, request, option)

        # 发起请求
        resp: RawResponse = await Transport.aexecute(self.config, request, option)

        # 反序列化
        response: DeleteUserMailboxMailContactResponse = JSON.unmarshal(str(resp.content, UTF_8),
                                                                        DeleteUserMailboxMailContactResponse)
        response.raw = resp

        return response

    def list(self, request: ListUserMailboxMailContactRequest,
             option: Optional[RequestOption] = None) -> ListUserMailboxMailContactResponse:
        if option is None:
            option = RequestOption()

        # 鉴权、获取 token
        verify(self.config, request, option)

        # 添加 content-type
        if request.body is not None:
            option.headers[CONTENT_TYPE] = f"{APPLICATION_JSON}; charset=utf-8"

        # 发起请求
        resp: RawResponse = Transport.execute(self.config, request, option)

        # 反序列化
        response: ListUserMailboxMailContactResponse = JSON.unmarshal(str(resp.content, UTF_8),
                                                                      ListUserMailboxMailContactResponse)
        response.raw = resp

        return response

    async def alist(self, request: ListUserMailboxMailContactRequest,
                    option: Optional[RequestOption] = None) -> ListUserMailboxMailContactResponse:
        if option is None:
            option = RequestOption()

        # 鉴权、获取 token
        verify(self.config, request, option)

        # 发起请求
        resp: RawResponse = await Transport.aexecute(self.config, request, option)

        # 反序列化
        response: ListUserMailboxMailContactResponse = JSON.unmarshal(str(resp.content, UTF_8),
                                                                      ListUserMailboxMailContactResponse)
        response.raw = resp

        return response

    def patch(self, request: PatchUserMailboxMailContactRequest,
              option: Optional[RequestOption] = None) -> PatchUserMailboxMailContactResponse:
        if option is None:
            option = RequestOption()

        # 鉴权、获取 token
        verify(self.config, request, option)

        # 添加 content-type
        if request.body is not None:
            option.headers[CONTENT_TYPE] = f"{APPLICATION_JSON}; charset=utf-8"

        # 发起请求
        resp: RawResponse = Transport.execute(self.config, request, option)

        # 反序列化
        response: PatchUserMailboxMailContactResponse = JSON.unmarshal(str(resp.content, UTF_8),
                                                                       PatchUserMailboxMailContactResponse)
        response.raw = resp

        return response

    async def apatch(self, request: PatchUserMailboxMailContactRequest,
                     option: Optional[RequestOption] = None) -> PatchUserMailboxMailContactResponse:
        if option is None:
            option = RequestOption()

        # 鉴权、获取 token
        verify(self.config, request, option)

        # 发起请求
        resp: RawResponse = await Transport.aexecute(self.config, request, option)

        # 反序列化
        response: PatchUserMailboxMailContactResponse = JSON.unmarshal(str(resp.content, UTF_8),
                                                                       PatchUserMailboxMailContactResponse)
        response.raw = resp

        return response
